// DeCrunch library
//
// (c) 1987 Copyright, Andrew Binstock   
// Modified for use with the GBA by Mic, 2001
//


#include <stdlib.h>


#define     EOS         -1      //End Of Stream
#define     TRIGGER     0xFE
#define     BUFSIZE     1024


unsigned char *dc_buffer,*dc_buffer2;
int stream_length, dc_stream_offset;
int eos;



int fill_buffer()
{
int res;

  if (dc_stream_offset == stream_length)
    return EOS;
  else
  {
    dc_buffer = (dc_buffer2 + dc_stream_offset);
    if ((dc_stream_offset + BUFSIZE) > stream_length)
    {
      res = (stream_length - dc_stream_offset);
      dc_stream_offset = stream_length;
      return res;
    } else
    {
      dc_stream_offset += BUFSIZE;
      return BUFSIZE;
    }
  }
}



void DeCrunch(unsigned char *src, unsigned char *dest)
{
  int bytes,count,i;

  stream_length = *((int *)src);
  dc_buffer = src+4;
  dc_buffer2 = dc_buffer;


  eos = 0;
  while (!eos)
  {
    bytes = fill_buffer();
    if (bytes == EOS)
    {
      eos = 1;
      break;
    }

    for (i=0; i<bytes; i++)
    {
      if (dc_buffer[i] != TRIGGER)
      {
        *(dest) = dc_buffer[i];
        dest++;
      } else
      {
        if (i == (bytes-1))
        {
          bytes = fill_buffer();
          i = -1;
        }

        if (dc_buffer[++i] == 0)
        {
          *(dest) = TRIGGER;
          dest++;
        } else
        {
          count = dc_buffer[i];
          if (i == (bytes-1))
          {
            bytes = fill_buffer();
            i = -1;
          }
          i++;
          while (count--)
          {
            *(dest) = dc_buffer[i];
            dest++;
          }
        }
      } 
    }
    if (bytes<BUFSIZE)
      break;
  }
}


  